if(!isFunction(Projectile,onRemove)) //not sure if anyone uses this function. it doesn't exist by default, but it's nature suggests packaging.
	exec("./spamfix1.cs");	//one of those things that should just be a blank function in the base files.
if(!isFunction(Weapon,onRemove))
	exec("./spamfix2.cs");
package SportsEvents
{
	function Player::dropBall( %obj ) //gotta copy the whole function because it doesn't return %p.
	{					//if you want the original commented code, refer to Item_Sports/support.cs
		if( !isObject( %obj ) )
			return;
		%image = %obj.getMountedImage( 0 );
		if( isObject( %image ) && %image.isSportBall )
			%dataBlock = %image.projectile;
		else
			return;
		%fVec = %obj.getForwardVector();
		%sVec = vectorScale( %fVec, 2 );
		%vec = vectorAdd( %sVec, "0 0 4" );
		%playerVel = getWords( %obj.getVelocity(), 0, 1 ) SPC getWord( %obj.getVelocity(), 2 )/2;
		%fVel = vectorAdd( %playerVel, %vec );
		if( %image.projectile $= "footballProjectile" )
			%initialPos = vectorAdd( %fVec, %obj.getMuzzlePoint( 0 ) );
		else
			%initialPos = %obj.getMuzzlePoint( 0 );
		%p = new Projectile()
		{
			dataBlock		 = %dataBlock;
			initialPosition = %initialPos;
			initialVelocity = %fVel;
			sourceObject	 = %obj;
			client			 = %obj.client;
			sourceSlot		= 0;
			originPoint	  = %obj.getMuzzlePoint( 0 );
			scale			= %obj.getScale();
			minigame = getMiniGameFromObject( %obj );
			bricksource = %obj.ballbricksource;
		};
		MissionCleanup.add(%p);
		%obj.sbTimeout = getSimTime()+500;
		%obj.unmountImage( 0 );
		return %p;
	}
	function footballProjectile::onRest(%this,%obj,%col,%fade,%pos,%normal) //same as above.
	{
		if(%obj.haveSpawnedItem)
			return;
		else
			%obj.haveSpawnedItem = 1;
		%item = new item()
		{
			dataBlock = "footballItem";
			scale = %obj.getScale();
			minigame = getMiniGameFromObject( %obj );
			sourceObject = %obj.sourceObject;
			isFumbled = %obj.isFumbled;
			spawnBrick = %obj.spawnBrick;
			bricksource = %obj.bricksource;
		};
		missionCleanup.add(%item);	
		%rot = hGetAnglesFromVector( vectorNormalize(%obj.lVelocity) );
		%item.setTransform(%obj.getPosition() SPC  "0 0 1" SPC %rot);
		%item.schedulePop();
		%item.isSportBall = 1;
		%obj.pickedup = 1;
		%obj.delete();
		if(%bricksource)
		{
		}
	}
	function soccerBallProjectile::onRest(%this,%obj,%col,%fade,%pos,%normal)
	{
		if(%obj.haveSpawnedItem)
			return;
		else
			%obj.haveSpawnedItem = 1;
		%item = new item()
		{
			dataBlock = "soccerBallItem";
			scale = %obj.getScale();
			minigame = getMiniGameFromObject( %obj );
			spawnBrick = %obj.spawnBrick;
			sourceObject = %obj.sourceObject;
			bricksource = %obj.bricksource;
		};
		missionCleanup.add(%item);   
		%rot = hGetAnglesFromVector( vectorNormalize(%obj.lVelocity) );
		%item.setTransform( %obj.getPosition() SPC  "0 0 1" SPC %rot);
		%item.schedulePop();
		%item.isSportBall = 1;
		%obj.pickedup = 1;
		%obj.delete();
	}
	function passBallCheck(%ball, %player, %isBrickItem)
	{
		%bricksource = %ball.bricksource; //set this before picking the ball up, as if it's not static, it will be deleted.
		if(!%bricksource) //maybe it just hasn't ever been picked up yet.
			%bricksource = %ball.spawnBrick;
		%ball.pickedup = 1; //set this flag so that we don't trigger the onBallPop event from someone picking it up.
		%ret = Parent::passBallCheck(%ball,%player,%isBrickItem);
		if(%ret)
			%player.ballbricksource = %bricksource;
		if(!%ret)
			%ball.pickedup = "";
		return %ret;
	}
	function Player::spawnBall(%obj, %db, %vel, %ns) //everything except soccer headbutt
	{
		%ret = Parent::spawnBall(%obj, %db, %vel, %ns);
		%ret.bricksource = %obj.ballbricksource;
		return %ret;
	}
	function spawnBall(%pos, %db, %vel, %source, %ns) //soccer headbutt
	{
		%ret = Parent::spawnBall(%pos, %db, %vel, %source, %ns);
		if(%source.getType() & $TypeMasks::FxBrickAlwaysObjectType)
			%ret.bricksource = %source;
		else
		{
			%ret.bricksource = %source.ballbricksource;
			if(!%ret.bricksource)
				%ret.bricksource = %source.bricksource;
		}
		return %ret;
	}
	function Projectile::onAdd(%this)
	{
		%ret = Parent::onAdd(%this);
		if(%this.sourceObject.getType() & $TypeMasks::FxBrickAlwaysObjectType)
			%this.bricksource = %this.sourceObject;
		return %ret;
	}
	function Projectile::onRemove(%this,%s)
	{
		if(!%this.pickedup && getWord(%this.dataBlock.uiName,0) $= "Ball" && !%this.haveSpawnedItem && isObject(%this.bricksource))
		{
			if(%this.sourceObject.getType() & $TypeMasks::PlayerObjectType)
				%player = %this.sourceObject;
			%client1 = %player.client;
			%client2 = %this.client;
			%this.bricksource.onBallPop(%player,%client1,%client2);
		}
		return Parent::onRemove(%this,%s);
	}
	function Weapon::onRemove(%data,%this)
	{
		if(%data.isSportBall && !%this.pickedup && isObject(%this.bricksource))
		{
			if(%this.sourceObject.getType() & $TypeMasks::PlayerObjectType)
				%player = %this.sourceObject;
			%client1 = %player.client;
			%client2 = %this.client;
			%this.bricksource.onBallPop(%player,%client1,%client2);
		}
		return Parent::onRemove(%this,%s);
	}
};
activatePackage(SportsEvents);

registerInputEvent("fxDTSBrick","onBallPop","Self fxDTSBrick\tLastHolder Player\tClient GameConnection\tMiniGame MiniGame");

function fxDTSBrick::onBallPop(%this,%player,%client1,%client2)
{
	$InputTarget_["Self"] = %this;
	$InputTarget_["LastHolder"] = %player;
	$InputTarget_["LastHClient"] = %client1;
	$InputTarget_["EventClient"] = %client2;
	$InputTarget_["MiniGame"] = getMinigameFromObject(%this);
	%this.processInputEvent("onBallPop",%client2);
}